require('ifdoc')

require('custprop')

-- The main function is the first function called from Iguana.
-- The Data argument will contain the message to be processed.
function main(Data)
   if Data:byte(1) ~= 123 --[[ 123 == '{' ]] then
      iguana.logDebug('Ignoring non-JSON message')
      return
   end
   
   local D = json.parse{data=Data}
   local ProjectGuid = D.ProjectGuid
   ifdoc.PROJECT_GUID = ProjectGuid
   
   if D.Complete then
      local ReportHtml = ifdoc.page.generateReport(ProjectGuid)
      ifdoc.db.execute('DELETE FROM InProgress')
   else
      local VirtualMain = ifdoc.initVirtualProjectEnv(ProjectGuid, D.SampleDataIndex)
      local SampleMessage = D.Data
      VirtualMain(SampleMessage)
   end
end