ifdoc.custprop = {}

local function trace(A,B,C) end

local function defExists(i)
   local RS = 
      ifdoc.db.execute('SELECT Id FROM CustomPropertyDef WHERE Id = '..i)
   if #RS > 0 then
      return true
   else
      return false
   end
end

function ifdoc.custprop.ensureDefsExist()
   for i,P in ipairs(ifdoc.customProperties) do
      if not defExists(i) then
         DefId = ifdoc.db.newGuid()
         ifdoc.db.execute('INSERT INTO CustomPropertyDef VALUES ('
            ..i..', \''..ifdoc.db.escape(P.name)..'\')')
      end
   end
end

function ifdoc.custprop.computeForField(T, Field, FieldDefId, Segment, Index)
   for i,P in ipairs(ifdoc.customProperties) do
      local Result = T:addRow()
      Result.CustomPropertyDefId = i
      Result.FieldDefId = FieldDefId
      local R = P.fieldFunc(Field, Segment, Index)
      if R ~= nil then
         Result.Result = tostring(R)
      else
         Result:remove('Result')
      end
   end
end

function ifdoc.custprop.calculateFinalResult(FieldDefId)
   local S = os.time()
   
   local RS = ifdoc.db.execute(
      'SELECT CustomPropertyDefId,Result FROM CustomProperty WHERE FieldDefId = \''
      ..ifdoc.db.escape(FieldDefId)..'\'')
   
   trackTime('SELECT CustomPropertyDefId, Result ...', S)
   
   local FRList = {}
   for i=1,#RS do
      local CPDI = tonumber(RS[i].CustomPropertyDefId:nodeValue())
      local P = ifdoc.customProperties[CPDI]
      local SinglePropResultList = FRList[CPDI]
      if not SinglePropResultList then
         SinglePropResultList = {}
         FRList[CPDI] = SinglePropResultList
      end
      if not RS[i].Result:isNull() then
         local ResultType = P.resultType
         local ResultValue = RS[i].Result:nodeValue()
         if ResultType == 'string' then
            SinglePropResultList[#SinglePropResultList+1] = ResultValue
         elseif ResultType == 'number' then
            SinglePropResultList[#SinglePropResultList+1] = tonumber(ResultValue)
         elseif ResultType == 'boolean' then
            SinglePropResultList[#SinglePropResultList+1] = (ResultValue == 'true')
         else
            error('Unrecognized custom property resultType: "'..P.resultTYpe..'"')
         end
      end
   end
   trace(FRList)
   for i,P in ipairs(ifdoc.customProperties) do
      FRList[i] = P.finalResultFunc(FRList[i] or {})
   end
   return FRList
end
