ifdoc.iguana = {}

local ComponentLookup = {
   from_mapper       = {Name='From Translator',   GuidAttr='guid'},
   to_mapper         = {Name='To Translator',     GuidAttr='guid'},
   from_http         = {Name='From HTTPS',        GuidAttr='guid'},
   from_llp_listener = {Name='From LLP Listener', GuidAttr='ack_script'},
   message_filter    = {Name='Filter',            GuidAttr='translator_guid'}
}

function ifdoc.iguana.projectList()
   local F = io.open('IguanaConfiguration.xml', 'r')
   local ConfigXml = F:read('*a')
   F:close()
   local Doc = xml.parse{data=ConfigXml}
   
   local PList = {}
   
   local CC = Doc.iguana_config.channel_config
   for i=1,#CC do
      local Channel = CC[i]
      for j=1,#Channel do
         -- Exclude current channel
         if Channel.name:nodeValue() ~= iguana.channelName() then
            local Component = Channel[j]
            if not Component:isLeaf() then
               local CL = ComponentLookup[Component:nodeName()]
               if CL then
                  local GuidAttr = Component[CL.GuidAttr]
                  if GuidAttr then
                     local P = {}
                     P.channel = Channel.name:nodeValue()
                     P.guid = GuidAttr:nodeValue()
                     P.component = CL.Name
                     PList[#PList+1] = P
                  end
               end
            end
         end
      end
   end
   
   return PList
end

function ifdoc.iguana.getProjectName(ProjectGuid)
   local F = io.open('IguanaConfiguration.xml', 'r')
   local ConfigXml = F:read('*a')
   F:close()
   local Doc = xml.parse{data=ConfigXml}
   
   local CC = Doc.iguana_config.channel_config
   for i=1,#CC do
      local Channel = CC[i]
      for j=1,#Channel do
         local Component = Channel[j]
         if not Component:isLeaf() then
            local CL = ComponentLookup[Component:nodeName()]
            if CL then
               local GuidAttr = Component[CL.GuidAttr]
               if GuidAttr then
                  return Channel.name:nodeValue()..' ('..
                         CL.Name..')'
               end
            end
         end
      end
   end
   return nil
end
